
ostream& operator<<(ostream& lhs, const std::string& rhs)
{
	return lhs<<rhs.c_str();
}

istream& operator>>(istream& lhs, std::string& rhs)
{

	char temp[1024];
	lhs>>temp;
	rhs = std::string(temp);
	return lhs;
}


imagetype imgType(const std::string& str)
{
	if (str.substr(str.size()-3, 3) == "JPG" || str.substr(str.size()-3, 3) == "Jpg" || str.substr(str.size()-3, 3) == "jpg")
		return JPEG;
	else if (str.substr(str.size()-3, 3) == "PNG" || str.substr(str.size()-3, 3) == "Png" || str.substr(str.size()-3, 3) == "png")
		return PNG;
	else
		return SCREEN;
}


class coord2d
{
public:
	int x, y;
	inline coord2d() : x(0), y(0) {}
	inline coord2d(const int xCoord, const int yCoord) : x(xCoord), y(yCoord) {}
};

inline ostream& operator << (ostream& lhs, const coord2d& rhs)
{
	return lhs << '(' << rhs.x << ',' << rhs.y << ')';
}

class spritePic
{
public:
	std::string fileName;
	char type;

	spritePic() {}
	spritePic(const std::string& filename, char tp = 'e') : type(tp) { init(filename); }
	void init(const std::string& filename) { fileName = filename; pic.Open(fileName, imgType(fileName)); 
											 if (!pic.Valid()) type = 'e'; }
#ifdef CMUG1
	image pic;
#endif
};

class sprite
{
public:
	unsigned short index;
	spritePic* link;
	sprite() : index(0) {}
	sprite(const unsigned short spriteIndex) { init(spriteIndex); }
	void init(const unsigned short spriteIndex) { index = spriteIndex; }
};

typedef char event;


typedef std::vector<sprite> svector;
typedef std::vector<svector> smatrix;


void resize(sprite** &vect, const int xSize, const int ySize)
{
	vect = new sprite*[xSize] ();

	for (int x = 0; x < xSize; x++)
		vect[x] = new sprite[ySize] ();
}

void resize(smatrix &vect, const int xSize, const int ySize)
{
	vect.resize(xSize);

	for (int x = 0; x < xSize; x++)
		vect[x].resize(ySize);
}



enum status
{
	PLAYING,
	WON,
	LOST,
	QUIT
};
