
void world2d::showTxtWorld()
{
	int x,y;

	if (worldXSize >= 1)
	{
		for (y = 0; y < worldYSize; y++)
		{
			for (x = 0; x < worldXSize; x++)
				cout<<world[x][y].index << '\t';

			cout<<endl;
		}
	}

	cout<<endl <<endl;

	for (x = 0; x < spritesSize; x++)
		cout<< x << '\t' << sprites[x].fileName <<endl;
}


inline void world2d::loadWorld(ifstream& fin)
{
	fin>>worldXSize;
	fin>>worldYSize;

	resize(world,worldXSize,worldYSize);

	int x,y;
	int tempIndex;

	for (y = 0; y < worldYSize; y++)
		for (x = 0; x < worldXSize; x++)
		{
			fin>>tempIndex;
			world[x][y] = tempIndex;
		}
}


inline void world2d::loadSprites(ifstream& fin)
{
	fin>>spritesSize;

	#ifdef USE_C_ARRAYS
		sprites = new spritePic[spritesSize] ();
	#else
		sprites.resize(spritesSize);
	#endif

	std::string tempFileName;
	char tempSpriteType;

	for (int x = 0; x < spritesSize; x++)
	{
		fin>>tempFileName;
		sprites[x].init(tempFileName);

		fin>>tempSpriteType;
		sprites[x].type = tempSpriteType;
	}
}

inline void world2d::syncPointers()
{
	int x, y;

	static spritePic err("errPic.jpg");

	for (x = 0; x < worldXSize; x++)
		for (y = 0; y < worldYSize; y++)
			if (world[x][y].index >= 0 && world[x][y].index < spritesSize)
				world[x][y].link = &(sprites[ world[x][y].index ]);
			else
				world[x][y].link = &err;
}

inline coord2d world2d::coordOfSprite(const coord2d& coord, const coord2d& loc)
{
	return coord2d((coord.x-loc.x)/spriteWidth, (coord.y-loc.y)/spriteHeight);
}

inline unsigned short world2d::indexOfSprite(const coord2d& coord)
{
	if ((coord.x >= 0 && coord.x < worldXSize) && (coord.y >= 0 && coord.y < worldYSize))
		return world[coord.x][coord.y].index;
	else
		return 65535;
}


inline unsigned short world2d::findSpriteIndex(const char type)
{
	for (unsigned short x = 0; x < spritesSize; x++)
		if (sprites[x].type == type)
			return x;

	return 65535;
}

void world2d::drawPage(const std::string &str)
{
	win->SetPen(BLACK);
	win->SetBrush(BLACK);
	win->DrawRectangle(0,0,win->GetWidth(),win->GetHeight());

	win->SetFont(48,PLAIN,ROMAN);
	win->SetPen(GREEN);

	int xSize, ySize;

	win->GetStringSize(xSize,ySize, str);
	win->DrawString((win->GetWidth()-xSize)/2, (win->GetHeight()-ySize)/2, str);

	win->UpdateBuffer();

	win->FlushKeyQueue();

	char tmpHolder;
	win->WaitKeyPress(tmpHolder);
}