
world2d::world2d(const std::string& srcFile, const std::string& characterIcon,
	const std::string& title = "Game",
	const int winWidth = 640, const int winHeight = 480,
	const int spritewidth = 24, const int spriteheight = 24)
	: quitEvent(27), moveUpEvent('i'), moveDownEvent('k'), moveLeftEvent('j'), jumpEvent(' '),
	  moveRightEvent('l'), spriteWidth(spritewidth), spriteHeight(spriteheight), 
	  defMoveSpeed(12), defJumpHeight(8), pos(284,36), charStatus(PLAYING), 
	  bkgd(NULL), jumpStatus(-1), myWin(true)
{
	win = new window(winWidth, winHeight);

	win->ChangeTitle(title);
	win->SetBuffering(true);
	win->SetWaitClose(false);

	character.Open(characterIcon,JPEG);

	ifstream fin;
	fin.open(srcFile.c_str());
	
	loadWorld(fin);
	loadSprites(fin);

	syncPointers();

	drawPage("Press any key to begin");
}

world2d::world2d(const std::string& srcFile, const std::string& characterIcon,
	const std::string& title, window* wind,
	const int spritewidth = 24, const int spriteheight = 24)
		: quitEvent(27), moveUpEvent('i'), moveDownEvent('k'), moveLeftEvent('j'), jumpEvent(' '),
	  moveRightEvent('l'), spriteWidth(spritewidth), spriteHeight(spriteheight), 
	  defMoveSpeed(12), defJumpHeight(8), pos(284,36), charStatus(PLAYING), 
	  win(wind), bkgd(NULL), jumpStatus(-1), myWin(false)
{
	win->ChangeTitle(title);
	win->SetBuffering(true);
	win->SetWaitClose(false);

	character.Open(characterIcon,JPEG);

	ifstream fin;
	fin.open(srcFile.c_str());
	
	loadWorld(fin);
	loadSprites(fin);

	syncPointers();

	drawPage("Press any key to begin");
}

world2d::~world2d()
{
	delete bkgd;

	#ifdef USE_C_ARRAYS
		for (int x = 0; x < worldXSize; x++)
			delete [] world[x];

		delete [] world;

		delete [] sprites;
	#endif

	if (myWin) delete win;
}