
inline bool world2d::run()
{
	coord2d tmpPos;

	eventScan(tmpPos);

	checkBlocks(tmpPos);

	manageJump();

	#ifdef CMUG1
		drawUsingCMUG1();
	#endif

	return (key != quitEvent);
}

inline void world2d::eventScan(coord2d& tmpPos)
{
	tmpPos = pos;

	if (!(win->GetKeyPress(key) == NO_KEYPRESS))
	{
		//if (key == moveUpEvent) pos.y += defMoveSpeed;
		if (key == moveDownEvent) pos.y -= defMoveSpeed;
		if (key == moveLeftEvent) pos.x += defMoveSpeed;
		if (key == moveRightEvent) pos.x -= defMoveSpeed;

		if (key == quitEvent) charStatus = QUIT;
	}

	if (key == jumpEvent && jumpStatus == 0) jumpStatus = 1;
}

inline void world2d::manageJump()
{
	coord2d blokBelowLoc = coordOfSprite(coord2d(win->GetWidth()/2,win->GetHeight()/2), 
												 coord2d(pos.x, pos.y - defMoveSpeed));

	if ((blokBelowLoc.y >= 0 && blokBelowLoc.y < worldYSize) && 
		(blokBelowLoc.x >= 0 && blokBelowLoc.x < worldXSize))
	{
		char type = world[blokBelowLoc.x][blokBelowLoc.y].link->type;

		if (jumpStatus <= 0)
		{
			if (type != 'e' && (type == 'W' || type == 'B'))
				jumpStatus = 0;
			else
				jumpStatus = -1;
		}
	}
}

inline void world2d::checkBlocks(const coord2d& tmpPos)
{
	if (jumpStatus > 0)
	{
		pos.y += defMoveSpeed;
		jumpStatus++;
	}

	if (jumpStatus == defJumpHeight)
		jumpStatus = -1;

	if (jumpStatus < 0)
		pos.y -= defMoveSpeed;

	coord2d thisCoord = coordOfSprite(coord2d(win->GetWidth()/2,win->GetHeight()/2), pos);
	unsigned short temp = indexOfSprite(thisCoord);

	if ((thisCoord.y >= 0 && thisCoord.y < worldYSize) && 
		(thisCoord.x >= 0 && thisCoord.x < worldXSize))
	{
		switch (world[thisCoord.x][thisCoord.y].link->type)
		{
			case 'W' : case 'B' : pos = tmpPos; break;
			case 'G' : charStatus = WON; break;
			case 'T' : charStatus = LOST; break;
		}

		thisCoord.y --;

		if (thisCoord.y >= 0)
		{
			sprite* tempWorld = &world[thisCoord.x][thisCoord.y];

			switch (tempWorld->link->type)
			{
				case 'B' : 
					if (jumpStatus > 0)
					{
						tempWorld->index = findSpriteIndex('F');
						tempWorld->link = &(sprites[ world[thisCoord.x][thisCoord.y].index ]);

						jumpStatus = -1;
					}
					break;
			}
		}
	}
	else
		charStatus = LOST;
}

inline void world2d::drawUsingCMUG1()
{
	if (bkgd == NULL)
	{
		static color tempHolder;
		tempHolder = win->SetPen(BLACK);
		win->SetBrush(BLACK);

		win->DrawRectangle(0,0,win->GetWidth(),win->GetHeight());

		win->SetPen(tempHolder);
	}
	else
		win->DrawImage(bkgd, 0,0,640,480);

	int xLoop, yLoop;

	for (xLoop = 0; xLoop < worldXSize; xLoop++)
		for (yLoop = 0; yLoop < worldYSize; yLoop++)
			win->DrawImage(world[xLoop][yLoop].link->pic, xLoop*spriteWidth+pos.x, yLoop*spriteHeight+pos.y);

	win->DrawImage(character, win->GetWidth()/2 - spriteWidth/2, win->GetHeight()/2 - spriteHeight/2);

	win->UpdateBuffer();
}
