
worldMgr::worldMgr(const std::string& bkgdImage, 
	const int winWidth, const int winHeight)
	: stdBkgdImage(bkgdImage), wC(0), world(NULL), win(winWidth, winHeight), quit(false) {}

worldMgr::worldMgr(const std::string& dataFile, const std::string& guyIcon, 
	const std::string& title, const std::string bkgdImage, 
	const int winWidth, const int winHeight)
	: stdBkgdImage(bkgdImage), wC(0), world(NULL), win(winWidth, winHeight), quit(false)
{	load(dataFile);	}

bool worldMgr::load(const std::string& dataFile, const std::string& guyIcon, 
		  const std::string& title)
{
	ifstream fin;
	fin.open(dataFile.c_str());

	if (fin)
	{
		int numOfFiles;
		fin>>numOfFiles;

		std::string fileName;

		for (int x = 0; x < numOfFiles; x++)
		{
			fin>>fileName;

			addWorld(fileName, guyIcon, title);
		}

		return true;
	}
	else
		return false;
}

inline bool worldMgr::run()
{
	if (world == NULL && wC < worlds.size())
		world = new world2d(worlds[wC].configFile, worlds[wC].guyIcon, worlds[wC].levelTitle, &win);

	bool beatLevel, done;

	if (world != NULL)
	{
		done = false;
		beatLevel = false;

		world->addBkgdImage(stdBkgdImage);

		while (world->run() && !done)
		{
			if (world->getStatus() == WON)
			{
				beatLevel = done = true;
				world->drawPage("You Won!");
			}
			if (world->getStatus() == LOST)
			{
				done = true;
				world->drawPage("You Lost!");
			}

			if (world->getStatus() == QUIT) quit = true;
		}

		if (done && wC < worlds.size())
		{
			if (beatLevel) wC++;

			delete world;
			world = NULL;
		}
	}

	return wC < worlds.size();
}
