#ifndef _WORLDMGR
#define _WORLDMGR

#include "world2d.h"

class worldData 
{
public:
	worldData() {}
	worldData(const std::string cfgFile, const std::string guy, const std::string levelTtl)
		: configFile(cfgFile), guyIcon(guy), levelTitle(levelTtl) {}

	std::string configFile;
	std::string guyIcon;
	std::string levelTitle; 
};

class worldMgr
{
	private:
		std::string stdBkgdImage;

		std::vector <worldData> worlds;
		int wC;
		world2d* world;

		window win;

		bool quit;

	public:
		worldMgr(const std::string& bkgdImage = "data/bkgd.jpg", 
			const int winWidth = 640, const int winHeight = 480);

		worldMgr(const std::string& dataFile, const std::string& guyIcon = "data/guy.jpg", 
			const std::string& title = "Game", const std::string bkgdImage = "data/bkgd.jpg", 
			const int winWidth = 640, const int winHeight = 480);

		bool load(const std::string& dataFile, const std::string& guyIcon = "data/guy.jpg", 
				  const std::string& title = "Game");

		inline void getBkgdImage(const std::string& bkgdImage)
		{	stdBkgdImage = bkgdImage;	}

		inline void addWorld(const std::string& configFile, const std::string& guyIcon, const std::string& levelTitle)
		{	worlds.push_back(worldData(configFile, guyIcon, levelTitle)); }

		inline bool run();

		inline void resetLevelCount()
		{	wC = 0;	}

		inline bool readyToQuit() { return quit; }
};

#include "worldMgr.cpp"


#endif	// worldmgr.h